"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var core_1 = require("@angular/core");
var event_manager_1 = require("@angular/platform-browser/src/dom/events/event_manager");
var OutsideEventPlugin = (function (_super) {
    __extends(OutsideEventPlugin, _super);
    function OutsideEventPlugin() {
        _super.apply(this, arguments);
    }
    OutsideEventPlugin.prototype.supports = function (eventName) {
        return eventName.indexOf('outside.') === 0;
    };
    OutsideEventPlugin.prototype.addEventListener = function (element, eventName, handler) {
        var realEventName = eventName.slice(8);
        return this.manager.addGlobalEventListener('document', realEventName, function (e) {
            if (element !== e.target && !element.contains(e.target)) {
                handler(e);
            }
        });
    };
    OutsideEventPlugin.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    OutsideEventPlugin.ctorParameters = function () { return []; };
    return OutsideEventPlugin;
}(event_manager_1.EventManagerPlugin));
exports.OutsideEventPlugin = OutsideEventPlugin;
