"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var core_1 = require("@angular/core");
var event_manager_1 = require("@angular/platform-browser/src/dom/events/event_manager");
var UndetectedEventPlugin = (function (_super) {
    __extends(UndetectedEventPlugin, _super);
    function UndetectedEventPlugin() {
        _super.apply(this, arguments);
    }
    UndetectedEventPlugin.prototype.supports = function (eventName) {
        return eventName.indexOf('undetected.') === 0;
    };
    UndetectedEventPlugin.prototype.addEventListener = function (element, eventName, handler) {
        var _this = this;
        var realEventName = eventName.slice(11);
        return this.manager.getZone().runOutsideAngular(function () {
            return _this.manager.addEventListener(element, realEventName, handler);
        });
    };
    UndetectedEventPlugin.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    UndetectedEventPlugin.ctorParameters = function () { return []; };
    return UndetectedEventPlugin;
}(event_manager_1.EventManagerPlugin));
exports.UndetectedEventPlugin = UndetectedEventPlugin;
